<ng-container *ngIf="!loading else loading_screen">
  <div *ngIf="user" class="d-flex justify-content-center">
    <div class="col-md-10 mt-4">
      <form #userForm=ngForm (ngSubmit)="save()">
        <div class="row justify-content-center">
          <div class="col-md-2 col-sm-4 px-md-0 mb-2">
            <div class="profile-pic" (click)="fileInput.click()">
              <img class="img-fluid" [src]="user.profile_path ? user.profile_path  : 'app/assets/img/avatar.jpg'" alt="profile-pic" />
              <div class="edit">
                <button type="button" class="btn btn-link">
                  <i class="fa fa-upload fa-lg"></i>
                </button>
              </div>
            </div>

            <input #fileInput class="d-none" type="file" (change)="fileChangeEvent($event)" />


          </div>

          <div class="col-md-10 col-sm-8">
            <div class="form-row mb-4">
              <div class="form-group col-md-3">
                <label for="first_name" class="control-label mb-1">First name</label>
                <input type="text" [(ngModel)]="user.first_name" name="first_name" class="form-control form-control-sm" placeholder="First name"
                  required>
                <span class="text-danger" [hidden]="!error.first_name">{{ error.first_name }}</span>
              </div>
              <div class="form-group col-md-3">
                <label for="middle_name" class="control-label mb-1">Middle name</label>
                <input type="text" [(ngModel)]="user.middle_name" name="middle_name" class="form-control form-control-sm" placeholder="Middle name"
                  required>
                <span class="text-danger" [hidden]="!error.middle_name">{{ error.middle_name }}</span>
              </div>
              <div class="form-group col-md-3">
                <label for="last_name" class="control-label mb-1">Last name</label>
                <input type="text" [(ngModel)]="user.last_name" name="last_name" class="form-control form-control-sm" placeholder="Last name"
                  required>
                <span class="text-danger" [hidden]="!error.last_name">{{ error.last_name }}</span>
              </div>
              <div class="form-group col-md-3">
                <label for="email" class="control-label mb-1">Email</label>
                <input type="email" [(ngModel)]="user.email" name="email" class="form-control form-control-sm" placeholder="Email" email
                  required>
                <span class="text-danger" [hidden]="!error.email">{{ error.email }}</span>
              </div>
            </div>

            <div class="form-row mb-4">
              <div class="form-group col-md-2">
                <label for="birthdate" class="control-label mb-1">Birthdate</label>
                <input type="text" [(ngModel)]="user.birthdate" name="birthdate" class="form-control form-control-sm" [bsConfig]="bsConfig"
                  bsDatepicker placeholder="MM/DD/YYYY" required>
                <span class="text-danger" [hidden]="!error.birthdate">{{ error.birthdate }}</span>
              </div>
              <div class="form-group col-md-2">
                <label for="gender" class="control-label mb-1">Gender</label>
                <select [(ngModel)]="user.gender" name="gender" class="form-control form-control-sm">
                  <option value="Male" selected>Male</option>
                  <option value="Female">Female</option>
                </select>
                <span class="text-danger" [hidden]="!error.gender">{{ error.gender }}</span>
              </div>
              <div class="form-group col-md-2">
                <label for="marital_status" class="control-label mb-1">Marital status</label>
                <select [(ngModel)]="user.marital_status" name="marital_status" class="form-control form-control-sm">
                  <option value="Single">Single</option>
                  <option value="Married">Married</option>
                  <option value="Widowed">Widowed</option>
                  <option value="Divorced">Divorced</option>
                </select>
                <span class="text-danger" [hidden]="!error.marital_status">{{ error.marital_status }}</span>
              </div>
              <div class="form-group col-md-3">
                <label for="mobile_number" class="control-label mb-1">Mobile number</label>
                <input type="text" [(ngModel)]="user.mobile_number" name="mobile_number" class="form-control form-control-sm" placeholder="Mobile number">
                <span class="text-danger" [hidden]="!error.mobile_number">{{ error.mobile_number }}</span>
              </div>
              <div class="form-group col-md-3">
                <label for="phone_number" class="control-label mb-1">Phone number</label>
                <input type="text" [(ngModel)]="user.phone_number" name="phone_number" class="form-control form-control-sm" placeholder="Phone number">
                <span class="text-danger" [hidden]="!error.phone_number">{{ error.phone_number }}</span>
              </div>
            </div>
          </div>
        </div>

        <ng-container *ngTemplateOutlet="parentInfo"></ng-container>

        <div class="form-row mb-4">
          <div class="form-group col-md-5">
            <label for="address_1" class="control-label mb-1">Address 1</label>
            <textarea [(ngModel)]="user.address_1" name="address_1" class="form-control form-control-sm" rows="4"></textarea>
            <span class="text-danger" [hidden]="!error.address_1">{{ error.address_1 }}</span>
          </div>
          <div class="form-group col-md-3">
            <label for="address_2" class="control-label mb-1">Address 2</label>
            <textarea [(ngModel)]="user.address_2" name="address_2" class="form-control form-control-sm" rows="4"></textarea>
            <span class="text-danger" [hidden]="!error.address_2">{{ error.address_2 }}</span>
          </div>
          <div class="form-group col-md-4">
            <label for="address_3" class="control-label mb-1">Address 3</label>
            <textarea [(ngModel)]="user.address_3" name="address_3" class="form-control form-control-sm" rows="4"></textarea>
            <span class="text-danger" [hidden]="!error.address_3">{{ error.address_3 }}</span>
          </div>
        </div>

        <div class="form-row mb-4">
          <div class="form-group col-md-5">

            <label for="country_name" class="control-label mb-1">Country</label>
            <div class="input-group">
              <select [(ngModel)]="user.country_id" (change)="getStates()" name="country_name" class="form-control form-control-sm" placeholder="Country">
                <option *ngFor="let country of countries" [ngValue]="country.id">{{ country.country_name }}</option>
              </select>
              <button type="button" class="btn btn-default rounded-right border-left-0 btn-flat btn-sm text-green mr-2" placement="bottom"
                [ngbPopover]="popAddCountryContent" [popoverTitle]="popAddCountryTitle" container="body" [autoClose]="'outside'"
                #addCountryPop="ngbPopover">
                <span class="fa fa-plus"></span>
              </button>

            </div>

          </div>
          <div class="form-group col-md-5">
            <label for="state_name" class="control-label mb-1">State</label>
            <div class="input-group">
              <select [(ngModel)]="user.state_id" (change)="getCities()" name="state_name" class="form-control form-control-sm">
                <option *ngFor="let state of states" [ngValue]="state.id">{{ state.state_name }}</option>
              </select>
              <button *ngIf="user.country_id" type="button" class="btn btn-default rounded-right border-left-0 btn-flat btn-sm text-green mr-2"
                placement="bottom" [ngbPopover]="popAddStateContent" [popoverTitle]="popAddStateTitle" container="body" [autoClose]="'outside'"
                #addStatePop="ngbPopover">
                <span class="fa fa-plus"></span>
              </button>
            </div>

          </div>
          <div class="form-group col-md-4">

            <label for="city" class="control-label mb-1">City</label>
            <div class="input-group">
              <select [(ngModel)]="user.city_id" (change)="getPostalCodes()" name="city" class="form-control form-control-sm">
                <option *ngFor="let city of cities" [ngValue]="city.id">{{ city.city_name }}</option>
              </select>
              <button *ngIf="user.state_id" type="button" class="btn btn-default rounded-right border-left-0 btn-flat btn-sm text-green mr-2"
                placement="bottom" [ngbPopover]="popAddCityContent" [popoverTitle]="popAddCityTitle" container="body" [autoClose]="'outside'"
                #addCityPop="ngbPopover">
                <span class="fa fa-plus"></span>
              </button>

            </div>

          </div>
          <div class="form-group col-md-4">

            <label for="postal_code" class="control-label mb-1">Postal code</label>

            <div class="input-group">
              <select [(ngModel)]="user.postal_code_id" name="postal_code" class="form-control form-control-sm">
                <option *ngFor="let pc of postal_codes" [ngValue]="pc.id">{{ pc.postal_code }}</option>
              </select>
              <button *ngIf="user.city_id" type="button" class="btn btn-default rounded-right border-left-0 btn-flat btn-sm text-green mr-2"
                placement="bottom" [ngbPopover]="popAddPostalCodeContent" [popoverTitle]="popAddPostalCodeTitle" container="body"
                [autoClose]="'outside'" #addPostalCodePop="ngbPopover">
                <span class="fa fa-plus"></span>
              </button>
            </div>

          </div>

        </div>
        <ng-container *ngTemplateOutlet="studentInfo"></ng-container>
        <div class="form-row mb-4">
          <div class="form-group col-md-3">
            <label for="username" class="control-label mb-1">Username</label>
            <input type="text" [(ngModel)]="user.username" name="username" class="form-control form-control-sm" placeholder="Username"
              required>
            <span class="text-danger" [hidden]="!error.username">{{ error.username }}</span>
          </div>
          <div class="form-group col-md-3">
            <label for="password" class="control-label mb-1">Password</label>
            <input type="password" [(ngModel)]="user.password" name="password" class="form-control form-control-sm" placeholder="Password"
              required>
            <span class="text-danger" [hidden]="!error.password">{{ error.password }}</span>
          </div>
          <div class="form-group col-md-3">
            <label for="password_confirmation" class="control-label mb-1">Confirm password</label>
            <input type="password" [(ngModel)]="user.password_confirmation" name="password_confirmation" class="form-control form-control-sm"
              placeholder="Confirm password" required>
            <span class="text-danger" [hidden]="!error.password_confirmation">{{ error.password_confirmation }}</span>
          </div>
        </div>
        <ng-container *ngTemplateOutlet="userAccess"></ng-container>

        <div class="container">
          <div class="row">
            <div class="col-md-12">
              <div class="d-flex flex-row-reverse">
                <button (click)="cancel()" class="btn btn-sm btn-primary btn-flat">
                  <span class="fa fa-times"></span> Cancel
                </button>
                <button type="submit" class="btn btn-sm btn-primary btn-flat">
                  <span class="fa" [ngClass]="{'fa-spinner fa-spin':saving,'fa-save':!saving}"></span> Save
                </button>
              </div>
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>
</ng-container>

<ng-template #profilePicModal let-c="close">
  <div class="modal-header">
    <h4 class="modal-title"></h4>
    <button type="button" class="btn btn-link text-secondary" aria-label="Close" (click)="c()">
      <span class="fa fa-times"></span>
    </button>
  </div>
  <div class="modal-body">
    <image-cropper [imageChangedEvent]="imageChangedEvent" [maintainAspectRatio]="true" [aspectRatio]="4 / 4" [resizeToWidth]="155"
      format="jpeg" (imageCroppedBase64)="imageCroppedBase64($event)" (imageLoaded)="imageLoaded()" (loadImageFailed)="loadImageFailed()"
      style="max-height: 80%" [style.display]="cropperReady ? null : 'none'"></image-cropper>
  </div>
  <div class="modal-footer">
    <div class="form-group float-right mt-2 mb-1">
    </div>
  </div>
</ng-template>

<ng-template #parentInfo>
  <div class="d-flex justify-content-center mb-4" *ngIf="user.user_type === 4">
    <div class="col-md-10">
      <div class="card rounded-0">
        <div class="card-header rounded-0 bk-clr-three">

          <p class="font-weight-bold text-white m-0">Additional info</p>

        </div>
        <div class="card-body">

          <div class="form-row justify-content-center">
            <div class="form-group col-md-4">
              <label for="pg_code" class="control-label mb-1">PG code</label>
              <input type="text" [(ngModel)]="user.parent.pg_code" name="pg_code" (change)="createUsername()" class="form-control form-control-sm"
                placeholder="PG code">
              <span class="text-danger" [hidden]="!error.pg_code">{{ error.pg_code }}</span>
            </div>
            <div class="form-group col-md-4">
              <label for="section" class="control-label mb-1">Student</label>
              <select [(ngModel)]="user.parent.student_id" (change)="getSchedules()" name="student_id" class="form-control form-control-sm">
                <option [ngValue]="null">Select student</option>
                <option *ngFor="let a of students" [ngValue]="a.student.id">{{ a.getFullname() }}</option>
              </select>
              <span class="text-danger" [hidden]="!error.student_id">{{ error.student_id }}</span>
            </div>
            <div class="form-group col-md-4">
              <label for="pg_relationship" class="control-label mb-1">Relationship to student</label>
              <input type="text" [(ngModel)]="user.parent.pg_relationship" name="pg_relationship" class="form-control form-control-sm"
                placeholder="PG Relationship">
              <span class="text-danger" [hidden]="!error.pg_relationship">{{ error.pg_relationship }}</span>
            </div>
          </div>

        </div>
      </div>
    </div>
  </div>
</ng-template>
<ng-template #studentInfo>
  <div class="d-flex justify-content-center mb-4" *ngIf="user.user_type === 5">
    <div class="col-md-10">
      <div class="card rounded-0">
        <div class="card-header rounded-0 bk-clr-three">
          <p class="font-weight-bold text-white m-0">Additional info</p>
        </div>
        <div class="card-body">
          <div class="form-row justify-content-center">
            <div class="form-group col-md-4">
              <label for="student_code" class="control-label mb-1">Student code</label>
              <input type="text" [(ngModel)]="user.student.student_code" name="student_code" class="form-control form-control-sm" placeholder="Student code">
              <span class="text-danger" [hidden]="!error.student_code">{{ error.student_code }}</span>
            </div>
            <div class="form-group col-md-4">
              <label for="student_number" class="control-label mb-1">Student number</label>
              <input type="text" [(ngModel)]="user.student.student_number" (change)="createUsername()" name="student_number" class="form-control form-control-sm"
                placeholder="Student number">
              <span class="text-danger" [hidden]="!error.student_number">{{ error.student_number }}</span>
            </div>
          </div>
          <div class="form-row justify-content-center">

            <div class="form-group col-md-4">
              <label for="level" class="control-label mb-1">Level</label>
              <select [(ngModel)]="user.student.level_id" (change)="getSections()" name="level_id" class="form-control form-control-sm">
                <option [ngValue]="null">Select year level</option>
                <option *ngFor="let a of levels" [ngValue]="a.id">{{ a.level_name }}</option>
              </select>
              <span class="text-danger" [hidden]="!error.level_id">{{ error.level_id }}</span>
            </div>
            <div class="form-group col-md-4">
              <label for="section" class="control-label mb-1">Section</label>
              <select [(ngModel)]="user.student.section_id" (change)="getSchedules()" name="section_id" class="form-control form-control-sm">
                <option [ngValue]="null">Select section</option>
                <option *ngFor="let a of sections" [ngValue]="a.id">{{ a.section_name }}</option>
              </select>
              <span class="text-danger" [hidden]="!error.section_id">{{ error.section_id }}</span>
            </div>
            <div class="form-group col-md-4">
              <label for="schedule" class="control-label mb-1">Schedule</label>
              <select [(ngModel)]="user.student.schedule_id" name="schedule_id" class="form-control form-control-sm">
                <option [ngValue]="null">Select schedule</option>
                <option *ngFor="let a of schedules" [ngValue]="a.id">{{ a.schedule_code }}</option>
              </select>
              <span class="text-danger" [hidden]="!error.schedule_id">{{ error.schedule_id }}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</ng-template>

<ng-template #userAccess>
  <div class="d-flex justify-content-center mb-4" *ngIf="user.user_type == 2 || user.user_type == 3">
    <div class="col-md-10">
      <div class="card rounded-0">
        <div class="card-header rounded-0 bk-clr-three">
          <div class="d-flex">

            <p class="font-weight-bold text-white m-0">User access</p>
            <button type="button" class="ml-auto btn btn-link btn-sm text-white mr-2" placement="top" [ngbPopover]="popAddFeatureContent"
              [popoverTitle]="popAddFeatureTitle" container="body" [autoClose]="'outside'" #addFeaturePop="ngbPopover">
              <span class="fa fa-plus"></span>
            </button>

            <ng-template #popAddFeatureTitle>
              <small>
                <b>
                  Add feature
                </b>
              </small>
            </ng-template>

            <ng-template #popAddFeatureContent>
              <table class="table small">
                <thead>
                  <tr>
                    <th class="p-2"></th>
                    <th class="p-2">Name</th>
                  </tr>
                </thead>
                <tbody>
                  <tr *ngFor="let feature of app_features">
                    <td class="p-2"><input type="checkbox" [checked]="isFeatureSelected(feature)" (change)="check_un($event,feature)"></td>
                    <td class="p-2">{{ feature.name | titlecase }}</td>
                  </tr>
                </tbody>

              </table>

            </ng-template>
          </div>
        </div>
        <div class="card-body">
          <div class="form-row justify-content-center">
            <table class="table small">
              <thead>
                <tr>
                  <th>Feature</th>
                  <th class="text-center">Add</th>
                  <th class="text-center">Edit</th>
                  <th class="text-center">Delete</th>
                  <th class="text-center">Option</th>

                </tr>
              </thead>
              <tbody>
                <tr *ngFor="let feature of user.user_access">
                  <td>{{ feature.name | titlecase }}</td>
                  <td class="text-center" class="text-center">
                    <input type="checkbox" [(ngModel)]="feature.pivot.can_add" [ngModelOptions]="{standalone: true}">
                  </td>
                  <td class="text-center" class="text-center">
                    <input type="checkbox" [(ngModel)]="feature.pivot.can_edit" [ngModelOptions]="{standalone: true}">
                  </td>
                  <td class="text-center" class="text-center">
                    <input type="checkbox" [(ngModel)]="feature.pivot.can_delete" [ngModelOptions]="{standalone: true}">
                  </td>
                  <td class="text-center">
                    <button type="button" class="btn btn-link btn-sm text-red" (click)="removeFeature(feature)">
                      <span class="fa fa-times"></span>
                    </button>
                  </td>

                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</ng-template>

<ng-template #popAddCountryTitle>
  <small>
    <b>
      Add country
    </b>
  </small>
</ng-template>

<ng-template #popAddCountryContent>
  <div class="form-group">
    <input type="text" class="form-control form-control-sm" name="cc" [(ngModel)]="obj.code" maxlength="5" placeholder="Country code"
      required>
  </div>
  <div class="form-group">
    <input type="text" class="form-control form-control-sm" name="cn" [(ngModel)]="obj.name" placeholder="Country name" required>
  </div>
  <div class="form-group">
    <input type="text" class="form-control form-control-sm" name="pc" [(ngModel)]="obj.phone_code" maxlength="5" placeholder="Phone code"
      required>
  </div>
  <button type="button" class="btn btn-link float-right mb-2 mt-0" (click)="saveCountry()">
    <span class="fa fa-save"></span>
  </button>
</ng-template>

<ng-template #popAddStateTitle>
  <small>
    <b>
      Add state
    </b>
  </small>
</ng-template>

<ng-template #popAddStateContent>
  <div class="form-group">
    <input type="text" class="form-control form-control-sm" name="sn" [(ngModel)]="obj.name" placeholder="State name" required>
  </div>
  <button type="button" class="btn btn-link float-right mb-2 mt-0" (click)="saveState()">
    <span class="fa fa-save"></span>
  </button>
</ng-template>

<ng-template #popAddCityTitle>
  <small>
    <b>
      Add city
    </b>
  </small>
</ng-template>

<ng-template #popAddCityContent>
  <div class="form-group">
    <input type="text" class="form-control form-control-sm" name="cn" [(ngModel)]="obj.name" placeholder="City name" required>
  </div>
  <button type="button" class="btn btn-link float-right mb-2 mt-0" (click)="saveCity()">
    <span class="fa fa-save"></span>
  </button>
</ng-template>

<ng-template #popAddPostalCodeTitle>
  <small>
    <b>
      Add postal code
    </b>
  </small>
</ng-template>

<ng-template #popAddPostalCodeContent>
  <div class="form-group">
    <input type="text" class="form-control form-control-sm" name="cc" [(ngModel)]="obj.code" maxlength="5" placeholder="Postal code"
      required>
  </div>

  <button type="button" class="btn btn-link float-right mb-2 mt-0" (click)="savePostaCode()">
    <span class="fa fa-save"></span>
  </button>
</ng-template>

<ng-template #loading_screen>
  <app-loading></app-loading>
</ng-template>